<?php
/**
 * Copyright (©) 2020 Pinpoint Designs LTD. All right's reserved.
 *
 * @category    Pinpoint
 * @copyright   Copyright (c) 2020 Pinpoint Designs. (http://www.pinpointdesigns.co.uk)
 * @author      Daniel Cuevas <daniel@pinpointdesigns.co.uk>
 */

namespace Pinpoint\AdminOnlyAmastyRates\Block\Adminhtml\Methods\Edit\Tab;

use Magento\Backend\Block\Widget\Form\Generic;

/**
 * Class Stores
 */
class Stores extends \Amasty\ShippingTableRates\Block\Adminhtml\Methods\Edit\Tab\Stores
{
    protected function _prepareForm()
    {
        $model = $this->_coreRegistry->registry('current_amasty_table_method');
        /** @var \Magento\Framework\Data\Form $form */
        $form = $this->_formFactory->create();
        $form->setHtmlIdPrefix('amstrates_');
        $fieldsetStores = $form->addFieldset('stores_fieldset', ['legend' => __('Visible In')]);

        $fieldsetStores->addField(
            'stores',
            'multiselect',
            [
                'name' => 'stores[]',
                'label' => __('Stores'),
                'title' => __('Stores'),
                'values'    => $this->getStoreOptions(),
                'note'=>__('Leave empty if there are no restrictions')
            ]
        );

        $fieldsetCustomers = $form->addFieldset('customers_fieldset', ['legend' => __('Applicable For')]);

        $customerGroups = $this->_groupRepository->getList($this->_searchCriteriaBuilder->create())->getItems();
        $fieldsetCustomers->addField(
            'cust_groups',
            'multiselect',
            [
                'name' => 'cust_groups[]',
                'label' => __('Customer Groups'),
                'title' => __('Customer Groups'),
                'note'=>__('Leave empty if there are no restrictions'),
                'values' => $this->_objectConverter->toOptionArray($customerGroups, 'id', 'code')
            ]
        );

        $form->setValues($model->getData());
        $this->setForm($form);
        return Generic::_prepareForm();
    }

    /**
     * @return array
     */
    protected function getStoreOptions()
    {
        $options = $this->_systemStore->getStoreValuesForForm(false, true);
        $options[0]['label'] = 'Admin';

        return $options;
    }
}
