<?php
/**
 * Copyright (©) 2020 Pinpoint Designs LTD. All right's reserved.
 *
 * @category    Pinpoint
 * @copyright   Copyright (c) 2020 Pinpoint Designs. (http://www.pinpointdesigns.co.uk)
 * @author      Daniel Cuevas <daniel@pinpointdesigns.co.uk>
 */

namespace Pinpoint\AdminOnlyAmastyRates\Model\ResourceModel\Method;

/**
 * Class Collection
 */
class Collection extends \Amasty\ShippingTableRates\Model\ResourceModel\Method\Collection
{
    /**
     * @param int|array $storeId
     * @return $this|\Amasty\ShippingTableRates\Model\ResourceModel\Method\Collection
     */
    public function addStoreFilter($storeId)
    {
        if (!is_array($storeId)) {
            return parent::addStoreFilter($storeId);
        }

        $condition = 'stores=""';
        foreach ($storeId as $id) {
            $condition .=  ' OR FIND_IN_SET("' . $id . '", `stores`)';
        }

        $this->getSelect()->where($condition);
        return $this;
    }
}
