<?php
/**
 * Copyright (©) 2020 Pinpoint Designs LTD. All right's reserved.
 *
 * @category    Pinpoint
 * @copyright   Copyright (c) 2020 Pinpoint Designs. (http://www.pinpointdesigns.co.uk)
 * @author      Daniel Cuevas <daniel@pinpointdesigns.co.uk>
 */

namespace Pinpoint\AdminOnlyAmastyRates\Plugin\Carrier;

use Magento\Framework\App\Area;
use Magento\Store\Model\Store;

/**
 * Class TablePlugin
 */
class TablePlugin
{
    /**
     * @var \Magento\Framework\App\State
     */
    private $state;

    /**
     * TablePlugin constructor.
     * @param \Magento\Framework\App\State $state
     */
    public function __construct(\Magento\Framework\App\State $state)
    {
        $this->state = $state;
    }

    public function afterGetStoreIdFromQuoteItem(\Amasty\ShippingTableRates\Model\Carrier\Table $subject, $result)
    {
        if ($this->state->getAreaCode() == Area::AREA_ADMINHTML) {
            return [$result, Store::DEFAULT_STORE_ID];
        }

        return $result;
    }
}
